<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use \Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\Libs\Util\Libraries\PHPMailer;
use \Teknisa\Libs\Util\DateUtil;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DTO;

class Ped03600ComissaoVendedorController extends TeknisaCrud {


    protected $parameterBag;
    protected $newCode;
    protected $environment;
    protected $entityManager;
    protected $dataSourceName;

    public function __construct($crudService, ParameterBag $parameterBag, $newCode, $environment, $entityManager) {
        parent::__construct($crudService, $parameterBag);
        $this->parameterBag = $parameterBag;
        $this->newCode = $newCode;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
    }

    public function salvar($request, $response) {
        $this->dataSourceName = 'vendedor_venditemped_pedido';
        $data = $request->getDataSet();
        $rows = $data->getRows();
        
    	$query = <<<SQL
		SELECT *
		  FROM VENDITEMPED
		 WHERE (NRPEDIDO    = :P_NRPEDIDO)
		   AND (NRITEMPED   = :P_NRITEMPED)
		   AND (CDFILIAL    = :P_CDFILIAL)
		   AND (CDVENDEDOR    = :P_CDVENDEDOR)
SQL;
        
        foreach ($rows as $row) {
    		$result = $this->entityManager->getConnection()->fetchAll($query, array(':P_NRPEDIDO'  => $row['NRPEDIDO'],
    															  ':P_NRITEMPED' => $row['NRITEMPED'],
    															  ':P_CDFILIAL' => $row['CDFILIAL'],
    															  ':P_CDVENDEDOR'  => $row['CDVENDEDOR']));
    		if(empty($result)){
                try {
                    $dataSet = new DataSet ("data", array($row->getArrayCopy()));
                    $requestDel = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
                    parent::save($requestDel, $response);
                } catch (\Exception $e) {
                    if(!(count($response->getError()))){
                        $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
                        throw $e;
                    }
                }
    		}else{
    		    $response->setError(new Error("Comissão do vendedor '". $row['NMFANVEN']. "' no item '". $row['NRITEMPED']. "' já cadastrada", 500));
    		}													  
    		
        }
        
    }

    
}