<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO\Response\Error;

class ped01100DadosPedidoController extends \Zeedhi\Framework\Controller\Report {

    protected $newCode;
    protected $environment;
    protected $par1;
    protected $par2;
    protected $reportService;
    
    public function __construct($newCode, $environment, $par1, $par2, ReportService $reportService){
        $this->newCode       = $newCode;
        $this->environment   = $environment;
        $this->reportService = $reportService;
	}
	
	protected $reportMapping = array (
        'PED01100' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        
                        "LCDFILIAL"             => "P_LCDFILIAL", 
                        "TCDFILIAL"             => "P_TCDFILIAL", 
                        "VENDEDORLISTA"         => "P_VENDEDORLISTA", 
                        "VENDEDORTODOS"         => "P_VENDEDORTODOS", 
                        "CLIENTELISTA"          => "P_CLIENTELISTA",    
                        "CLIENTETODOS"          => "P_CLIENTETODOS",    
                        "PRIORIDADE"            => "P_PRIORIDADE",    
                        "PRIORIDADETODOS"       => "P_PRIORIDADETODOS",  
                        "STATUS"                => "P_STATUS",                
                        "STATUSTODOS"           => "P_STATUSTODOS",      
                        "CDTIPOOPER"            => "P_CDTIPOOPER",    
                        "TCDTIPOOPER"           => "P_TCDTIPOOPER",  
                        "EMISSAODE"             => "P_EMISSAODE",  
                        "EMISSAOATE"            => "P_EMISSAOATE",    
                        "EMISSAOTODOS"          => "P_EMISSAOTODOS",    
                        "ENTREGADE"             => "P_ENTREGADE",  
                        "ENTREGAATE"            => "P_ENTREGAATE",    
                        "ENTREGATODOS"          => "P_ENTREGATODOS",    
                        "NRPEDIDODE"            => "P_INTERVALODE",        
                        "NRPEDIDOATE"           => "P_INTERVALOATE",      
                        "NRPEDIDOTODOS"         => "P_NRPEDIDOTODOS1",  
                        "NRPEDIDOLISTA"         => "P_NRPEDIDOLISTA",   
                        "TIPOPEDIDO"            => "P_TIPOPEDIDO",        
                        "TODOSPEDIDOS"          => "P_TODOSPEDIDOS",    
                        "NRORDEMCMPPED"         => "P_ORDEM",          
                        "PRODUTOLISTA"          => "P_PRODUTOLISTA",    
                        "PRODUTOTODOS"          => "P_PRODUTOTODOS",    
                        "STATUSITEM"            => "P_STATUSITEM",        
                        "STATUSITEMTODOS"       => "P_STATUSITEMTODOS",  
                        "VENDCOMISLISTA"        => "P_VENDCOMISLISTA",    
                        "VENDCOMISTODOS"        => "P_VENDCOMISTODOS",
                        "NRORG"                 => "P_NRORG"
                    ),
            ),
            
        'PED01101' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        
                        "LCDFILIAL"             => "P_LCDFILIAL", 
                        "TCDFILIAL"             => "P_TCDFILIAL", 
                        "VENDEDORLISTA"         => "P_VENDEDORLISTA", 
                        "VENDEDORTODOS"         => "P_VENDEDORTODOS", 
                        "CLIENTELISTA"          => "P_CLIENTELISTA",    
                        "CLIENTETODOS"          => "P_CLIENTETODOS",    
                        "PRIORIDADE"            => "P_PRIORIDADE",    
                        "PRIORIDADETODOS"       => "P_PRIORIDADETODOS",  
                        "STATUS"                => "P_STATUS",                
                        "STATUSTODOS"           => "P_STATUSTODOS",      
                        "CDTIPOOPER"            => "P_CDTIPOOPER",    
                        "TCDTIPOOPER"           => "P_TCDTIPOOPER",  
                        "EMISSAODE"             => "P_EMISSAODE",  
                        "EMISSAOATE"            => "P_EMISSAOATE",    
                        "EMISSAOTODOS"          => "P_EMISSAOTODOS",    
                        "ENTREGADE"             => "P_ENTREGADE",  
                        "ENTREGAATE"            => "P_ENTREGAATE",    
                        "ENTREGATODOS"          => "P_ENTREGATODOS",    
                        "NRPEDIDODE"            => "P_INTERVALODE",        
                        "NRPEDIDOATE"           => "P_INTERVALOATE",      
                        "NRPEDIDOTODOS"         => "P_NRPEDIDOTODOS1",  
                        "NRPEDIDOLISTA"         => "P_NRPEDIDOLISTA",   
                        "TIPOPEDIDO"            => "P_TIPOPEDIDO",        
                        "TODOSPEDIDOS"          => "P_TODOSPEDIDOS",    
                        "NRORDEMCMPPED"         => "P_ORDEM",          
                        "PRODUTOLISTA"          => "P_PRODUTOLISTA",    
                        "PRODUTOTODOS"          => "P_PRODUTOTODOS",    
                        "STATUSITEM"            => "P_STATUSITEM",        
                        "STATUSITEMTODOS"       => "P_STATUSITEMTODOS",  
                        "VENDCOMISLISTA"        => "P_VENDCOMISLISTA",    
                        "VENDCOMISTODOS"        => "P_VENDCOMISTODOS",
                        "NRORG"                 => "P_NRORG"
                    ),
            ),
            
        'PED01103' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        
                        "LCDFILIAL"             => "P_LCDFILIAL", 
                        "TCDFILIAL"             => "P_TCDFILIAL", 
                        "VENDEDORLISTA"         => "P_VENDEDORLISTA", 
                        "VENDEDORTODOS"         => "P_VENDEDORTODOS", 
                        "CLIENTELISTA"          => "P_CLIENTELISTA",    
                        "CLIENTETODOS"          => "P_CLIENTETODOS",    
                        "PRIORIDADE"            => "P_PRIORIDADE",    
                        "PRIORIDADETODOS"       => "P_PRIORIDADETODOS",  
                        "STATUS"                => "P_STATUS",                
                        "STATUSTODOS"           => "P_STATUSTODOS",      
                        "CDTIPOOPER"            => "P_CDTIPOOPER",    
                        "TCDTIPOOPER"           => "P_TCDTIPOOPER",  
                        "EMISSAODE"             => "P_EMISSAODE",  
                        "EMISSAOATE"            => "P_EMISSAOATE",    
                        "EMISSAOTODOS"          => "P_EMISSAOTODOS",    
                        "ENTREGADE"             => "P_ENTREGADE",  
                        "ENTREGAATE"            => "P_ENTREGAATE",    
                        "ENTREGATODOS"          => "P_ENTREGATODOS",    
                        "NRPEDIDODE"            => "P_INTERVALODE",        
                        "NRPEDIDOATE"           => "P_INTERVALOATE",      
                        "NRPEDIDOTODOS"         => "P_NRPEDIDOTODOS1",  
                        "NRPEDIDOLISTA"         => "P_NRPEDIDOLISTA",   
                        "TIPOPEDIDO"            => "P_TIPOPEDIDO",        
                        "TODOSPEDIDOS"          => "P_TODOSPEDIDOS",    
                        "NRORDEMCMPPED"         => "P_ORDEM",          
                        "PRODUTOLISTA"          => "P_PRODUTOLISTA",    
                        "PRODUTOTODOS"          => "P_PRODUTOTODOS",    
                        "STATUSITEM"            => "P_STATUSITEM",        
                        "STATUSITEMTODOS"       => "P_STATUSITEMTODOS",  
                        "VENDCOMISLISTA"        => "P_VENDCOMISLISTA",    
                        "VENDCOMISTODOS"        => "P_VENDCOMISTODOS",
                        "NRORG"                 => "P_NRORG"
                    ),
            ),
            
        'PED01104' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        
                        "LCDFILIAL"             => "P_LCDFILIAL", 
                        "TCDFILIAL"             => "P_TCDFILIAL", 
                        "VENDEDORLISTA"         => "P_VENDEDORLISTA", 
                        "VENDEDORTODOS"         => "P_VENDEDORTODOS", 
                        "CLIENTELISTA"          => "P_CLIENTELISTA",    
                        "CLIENTETODOS"          => "P_CLIENTETODOS",    
                        "PRIORIDADE"            => "P_PRIORIDADE",    
                        "PRIORIDADETODOS"       => "P_PRIORIDADETODOS",  
                        "STATUS"                => "P_STATUS",                
                        "STATUSTODOS"           => "P_STATUSTODOS",      
                        "CDTIPOOPER"            => "P_CDTIPOOPER",    
                        "TCDTIPOOPER"           => "P_TCDTIPOOPER",  
                        "EMISSAODE"             => "P_EMISSAODE",  
                        "EMISSAOATE"            => "P_EMISSAOATE",    
                        "EMISSAOTODOS"          => "P_EMISSAOTODOS",    
                        "ENTREGADE"             => "P_ENTREGADE",  
                        "ENTREGAATE"            => "P_ENTREGAATE",    
                        "ENTREGATODOS"          => "P_ENTREGATODOS",    
                        "NRPEDIDODE"            => "P_INTERVALODE",        
                        "NRPEDIDOATE"           => "P_INTERVALOATE",      
                        "NRPEDIDOTODOS"         => "P_NRPEDIDOTODOS1",  
                        "NRPEDIDOLISTA"         => "P_NRPEDIDOLISTA",   
                        "TIPOPEDIDO"            => "P_TIPOPEDIDO",        
                        "TODOSPEDIDOS"          => "P_TODOSPEDIDOS",    
                        "NRORDEMCMPPED"         => "P_ORDEM",          
                        "PRODUTOLISTA"          => "P_PRODUTOLISTA",    
                        "PRODUTOTODOS"          => "P_PRODUTOTODOS",    
                        "STATUSITEM"            => "P_STATUSITEM",        
                        "STATUSITEMTODOS"       => "P_STATUSITEMTODOS",
                        "NRORG"                 => "P_NRORG"
                    ),
            ),
        
        'PED01105' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        
                        "LCDFILIAL"             => "P_LCDFILIAL", 
                        "TCDFILIAL"             => "P_TCDFILIAL", 
                        "VENDEDORLISTA"         => "P_VENDEDORLISTA", 
                        "VENDEDORTODOS"         => "P_VENDEDORTODOS", 
                        "CLIENTELISTA"          => "P_CLIENTELISTA",    
                        "CLIENTETODOS"          => "P_CLIENTETODOS",    
                        "PRIORIDADE"            => "P_PRIORIDADE",    
                        "PRIORIDADETODOS"       => "P_PRIORIDADETODOS",  
                        "STATUS"                => "P_STATUS",                
                        "STATUSTODOS"           => "P_STATUSTODOS",      
                        "CDTIPOOPER"            => "P_CDTIPOOPER",    
                        "TCDTIPOOPER"           => "P_TCDTIPOOPER",  
                        "EMISSAODE"             => "P_EMISSAODE",  
                        "EMISSAOATE"            => "P_EMISSAOATE",    
                        "EMISSAOTODOS"          => "P_EMISSAOTODOS",    
                        "ENTREGADE"             => "P_ENTREGADE",  
                        "ENTREGAATE"            => "P_ENTREGAATE",    
                        "ENTREGATODOS"          => "P_ENTREGATODOS",    
                        "NRPEDIDODE"            => "P_INTERVALODE",        
                        "NRPEDIDOATE"           => "P_INTERVALOATE",      
                        "NRPEDIDOTODOS"         => "P_NRPEDIDOTODOS1",  
                        "NRPEDIDOLISTA"         => "P_NRPEDIDOLISTA",   
                        "TIPOPEDIDO"            => "P_TIPOPEDIDO",        
                        "TODOSPEDIDOS"          => "P_TODOSPEDIDOS",    
                        "NRORDEMCMPPED"         => "P_ORDEM",          
                        "PRODUTOLISTA"          => "P_PRODUTOLISTA",    
                        "PRODUTOTODOS"          => "P_PRODUTOTODOS",    
                        "STATUSITEM"            => "P_STATUSITEM",        
                        "STATUSITEMTODOS"       => "P_STATUSITEMTODOS",
                        "NRORG"                 => "P_NRORG"
                    ),
            ),
            
    );
    
    
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
    }

}
    