var Exp00200_lancamentoExpedicaoPedido_Service = function(Exp00200_lancamentoExpedicaoPedido_Repository, localStorageEngine, ScreenService, templateManager, ZHPromise, MessageService) {

    this.getFilialLogada = function(){
        return Exp00200_lancamentoExpedicaoPedido_Repository.retornaUnidadeLogada();
    };

    this.retornaEmpresa = function(cdempresa){
        return Exp00200_lancamentoExpedicaoPedido_Repository.retornaEmpresa(cdempresa);
    };

    this.expedirPedido = function(row){
        var operador = getLocalVar('CDOPERADOR');
        for(var i=0; i <row[0].length; i++){
            row[0][i].CDOPERADOR = operador;
        }
        return Exp00200_lancamentoExpedicaoPedido_Repository.expedirPedido(row);
    };

    this.getEstoqueData = function(row){
        return Exp00200_lancamentoExpedicaoPedido_Repository.getEstoqueData(row);
    };

    this.saveData = function(name, dataSource) {
        return localStorageEngine.save(name, dataSource);
    };

    this.setData = function(name, dataSource) {
        return localStorageEngine.setDataSource(name, dataSource);
    };

    this.getData = function(dataSourceName, filter) {
        filter = filter || [];
        return localStorageEngine.getDataSource(dataSourceName, null, filter, null, 999999999);
    };

    this.expedir = function(args){
        var serie = '';
        var empresa = '';
        var tipooper = '';
        var widget = args.owner.widget;
        var checkedRows = args.owner.widget.dataSource.getCheckedRows();
        if (checkedRows.length > 0){
            // widget.appliedFilter.forEach(function(filter){
            // if(widget.appliedFilter.FILTER_ROW.CDTIPOOPER !== ''){
                tipooper = widget.appliedFilter.FILTER_ROW.CDTIPOOPER;
            // }
            // });
            empresa = widget.CDEMPRESA;
            serie   = widget.CDSERIE;
            
            for (var i = 0; i < checkedRows.length; i++ ) {
                checkedRows[i].CDEMPRESA = empresa;
                checkedRows[i].CDSERIE = serie;
                if (widget.getField('NMTIPOOPER').requiredParam) {
                    checkedRows[i].CDTIPOOPER = tipooper;
                }
            }
            
            this.getData('ped_expedicao#/lotes_expedicao').then(function(localdata){
                var data = [checkedRows, localdata];
                this.expedirPedido(data).then(function(callback){
                        //ScreenService.showMessage('Pedido(s) expedido(s) com sucesso.');
                    widget.unSelectAll();
                    widget.reload();
                    var widgetRetornoExp = templateManager.container.getWidget('popUpRetornoExpedicao');
                    
                    callback.dataset.data.forEach(function(item){
                        item.DSERRO = ScreenService.i18n(item.DSERRO);
                        if(item.PRODUTO){
                            item.DSERRO = item.PRODUTO + item.DSERRO;    
                        }
                    });
                    
                    setTimeout(function(){
                        ZHPromise.all(ScreenService.openPopup(widgetRetornoExp)).then(function(){
                            widgetRetornoExp.dataSource.data = callback.dataset.data;
                            widget.reload();
                        });
                    }, 1000);                    
                }.bind(this)).catch(function(callback){
                    //ScreenService.showMessage(callback.data.error);
                    if(callback.data.error.indexOf("erro_lote") > -1){
                        var itemSemLote = "ITEM_NAO_POSSUI_LOTE";
                        var parametros = callback.data.error.split("/");
                        MessageService.showMessageByCode(itemSemLote,{"NMPRODUTO":parametros[1], "NRPEDIDO":parametros[2], "NMRAZSOCCLIE":parametros[3]});                    
                    }else{
                        ScreenService.showMessage(callback.data.error);
                    }
                    ScreenService.closePopup(widget).then(function(){
                        ScreenService.closePopup();
                    });
                }.bind(this));
                
            }.bind(this)).catch(function(callback){
                ScreenService.showMessage(callback.data.error);
            }.bind(this));
            
        } else {
            ScreenService.showMessage('Selecione algum pedido.');
        }
    };


};

Configuration(function(ContextRegister) {
    ContextRegister.register("Exp00200_lancamentoExpedicaoPedido_Service", Exp00200_lancamentoExpedicaoPedido_Service);
});