var Ped29000_manutencaoReserva_Controller = function(General, ScreenService, templateManager, ZHPromise, ZhFilterPreferences, Ped29000_manutencaoReserva_Service){

    this.verifyParameters = function(widget) {

        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            var filter = [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": response.dataset.filial[0].CDFILIAL
            }];

            General.callRestEngine('ped#/crud/parampedido', 'FilterData', filter).then(function(callback) {
                if(!callback.dataset.parampedido[0]) {
                    ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial logada.');
                }
            }.bind(this));
        }.bind(this));
    };

    this.startFiltering = function(widget){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilter(widget);
        }.bind(this)); 
        // this.setFilterDataSourceVazio();
    };
    
    this.setFilter = function(widget) {
        this.verifyParameters(widget);
        var filterRow = {};
        
        var NDate = new Date();
        var today = NDate.getDate() + "/" + parseInt(NDate.getMonth()+1)+ "/" + NDate.getFullYear();
        var interval = {
            "end" : today,
            "period" : undefined,
            "start" : '01/12/2021'//today
        };
        
        filterRow.DTPEDIDO = interval;
        
        // var filial;
        General.callRestEngine('ped#/crud/filial', 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function(response) {
            filterRow.CDFILIAL = response.dataset.filial[0].CDFILIAL;
            filterRow.NMFILIAL = response.dataset.filial[0].NMFILIAL;
            // filial = response.dataset.filial[0].CDFILIAL;
            
            templateManager.container.getActiveWidget().getField('NRPEDIDO').dataSourceFilter.push(
                {
                    name: "P_CDFILIAL",
                    operator: "=",
                    value: response.dataset.filial[0].CDFILIAL
                }
            );
            
            templateManager.container.getActiveWidget().currentRow = filterRow;

        }.bind(this));
        
    };
    
    this.setActiveTab = function(nameWidget){
        const widget = templateManager.container.getWidget(nameWidget);
        widget.activate();
    };
    
    this.backItemReserva = function(args) {
        var widgetItem = templateManager.container.getWidget('itens');
        widgetItem.rollbackInlineEdit();
        
        var widgetReserva = templateManager.container.getWidget('reserva');
        widgetReserva.rollbackInlineEdit();
    };
    
    this.actvateView = function() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        widgetPrincipal.activate();
        widgetPrincipal.view();
        this.actvateList();
    };
    
    this.actvateList = function() {
        const widgetPrincipal = templateManager.container.getWidget('widgetPrincipal');
        widgetPrincipal.list();
    };
    
    this.setDataSourceNrpedido = function(widget) {
        widget.currentRow.NRPEDIDO = '';
        widget.getField('NRPEDIDO').setValue('');
        widget.getField('NRPEDIDO').dataSourceFilter.push(
            {
                name: "P_CDFILIAL",
                operator: "=",
                value: widget.currentRow.CDFILIAL
            }
        );
        widget.getField('NRPEDIDO').reload();
    };
    
    this.setDataSourceFilterItem = function(widget) {
        var widItens = templateManager.container.getWidget('itens');
        widItens.dataSourceFilter = [];
        widItens.dataSourceFilter.push(
            {
                name: "CDFILIAL",
                operator: "=",
                value: General.getFieldValue('CDFILIAL','widgetPrincipal')
            }
        );
        widItens.dataSourceFilter.push(
            {
                name: "NRPEDIDO",
                operator: "=",
                value: General.getFieldValue('NRPEDIDO','widgetPrincipal')
            }
        );
        widItens.dataSourceFilter.push(
            {
                name: "NRITEMPED",
                operator: "=",
                value: General.getFieldValue('NRITEMPED','widgetPrincipal')
            }
        );
        widItens.reload();
    };
    
    this.setDataSourceFilterReserva = function(widget) {
        var widReserva = templateManager.container.getWidget('reserva');
        widReserva.dataSourceFilter = [];
        widReserva.dataSourceFilter.push(
            {
                name: "P_CDFILIAL",
                operator: "=",
                value: General.getFieldValue('CDFILIAL','widgetPrincipal')
            }
        );
        widReserva.dataSourceFilter.push(
            {
                name: "P_NRPEDIDO",
                operator: "=",
                value: General.getFieldValue('NRPEDIDO','widgetPrincipal')
            }
        );
        widReserva.dataSourceFilter.push(
            {
                name: "P_NRITEMPED",
                operator: "=",
                value: General.getFieldValue('NRITEMPED','widgetPrincipal')
            }
        );
        widReserva.dataSourceFilter.push(
            {
                name: "P_CDPRODUTO",
                operator: "=",
                value: General.getFieldValue('CDPRODUTO','widgetPrincipal')
            }
        );
        widReserva.reload();
    };
    
    this.qtdeTotalReserva = function(widgetReserva){
        // var qtdade = 0;
        var total = 0;
        widgetReserva.dataSource.data.forEach(function(row){
            if(isNaN(row.QTRESPRODPED) || row.QTRESPRODPED == null)
                row.QTRESPRODPED = 0;
                
            if(typeof row.QTRESPRODPED === 'string')
                row.QTRESPRODPED = parseFloat(row.QTRESPRODPED.replace(',','.'));
            else
                row.QTRESPRODPED = parseFloat(row.QTRESPRODPED);
            total = total + row.QTRESPRODPED;
        });
        return parseFloat(total);
    }; 

    this.onSaveItem = function() {
        var widgetItem = templateManager.container.getWidget('itens');
        var widgetReserva = templateManager.container.getWidget('reserva');
        
        // Quantidade total dos itens da reserva 
        var QTRESPRODPED = this.qtdeTotalReserva(widgetReserva);
        
        // Quantidade total do item
        var QTITEMPED = 0;
        if(typeof widgetItem.dataSource.data[0].QTITEMPED === 'string')
             QTITEMPED = parseFloat(widgetItem.dataSource.data[0].QTITEMPED.replace(',','.'));
        else
             QTITEMPED = parseFloat(widgetItem.dataSource.data[0].QTITEMPED);
        
        // Se a quantidade reservada for igual a quantidade do item
        if(QTITEMPED == QTRESPRODPED){
            
            var itens = [{
                        "CDFILIAL": General.getFieldValue('CDFILIAL','widgetPrincipal'),
                        "NRPEDIDO": General.getFieldValue('NRPEDIDO','widgetPrincipal'),
                        "NRITEMPED": General.getFieldValue('NRITEMPED','widgetPrincipal'),
                        "CDPRODUTO": General.getFieldValue('CDPRODUTO','widgetPrincipal'),
                        "QTITEMPED": QTITEMPED,
                        "changed": true,
                        "__is_new": false
                    }];
                    
            var reservas = [];
            widgetReserva.dataSource.data.forEach(function(row){
                reservas.push(
                    {
                        "CDFILIAL": General.getFieldValue('CDFILIAL','widgetPrincipal'),
                        "NRPEDIDO": General.getFieldValue('NRPEDIDO','widgetPrincipal'),
                        "NRITEMPED": General.getFieldValue('NRITEMPED','widgetPrincipal'),
                        "QTRESPRODPED": row.QTRESPRODPED,
                        "QTRESPRODARR": row.QTRESPRODPED,
                        "NRRESPRODPED": 'x',
                        "CDPRODUTO": row.CDPRODUTO,
                        "CDALMOXARIFE": row.CDALMOXARIFE,
                        "CDLOCALESTOQ": row.CDLOCALESTOQ ? row.CDLOCALESTOQ : " ",
                        "NRLOTEESTQ": row.NRLOTEESTQ ? row.NRLOTEESTQ : " ",
                        "NRSUBLOTE": row.NRSUBLOTE ? row.NRSUBLOTE : " ",
                        // "changed": true,
                        "__is_new": true
                    }
                );
            });
            
            var dataReserva = [itens, reservas];

            Ped29000_manutencaoReserva_Service.salvarManutencaoReserva(dataReserva).then((item)=>{

                widgetItem.commitInlineEdit();
                widgetItem.list();

                widgetItem.currentRow.changed = false;
                widgetItem.reload();
                
                widgetReserva.commitInlineEdit();
                widgetReserva.list();
                
                widgetReserva.currentRow.changed = false;
                widgetReserva.reload();

            },function(error){
                ScreenService.showMessage(error.data.error);
            });
        }else{
            ScreenService.showMessage('Quantidade reservada deve ser igual a quantidade do item do pedido');
        }
    };
    
}; 

Configuration(function(ContextRegister){
    ContextRegister.register('Ped29000_manutencaoReserva_Controller', Ped29000_manutencaoReserva_Controller);
});