var ped02000_relatorio_customizavel_curvaabc_Controller = function(ScreenService, templateManager, ZhFilterPreferences, General, ZHPromise){
/*global Configuration*/ 
    
    this.openFilter = function(widget){
    var promises = [];
    promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
    promises.push(ZhFilterPreferences.openFilterWidget(widget));
    ZHPromise.all(promises).then(function(rowSetFilter){
        ScreenService.showMessage('validações aqui');
    }.bind(this)); 
};
    
    this.setDataSourceFilterApply = function(args){
        
        var valuesWidget = templateManager.container.factoredWidgets.filter((widget) => {return widget._filteredWidgetId == args.owner.id;});
        var rowPopup = valuesWidget[0].currentRow;
        var readonlyVendedor = valuesWidget[0].getField('CDVENDEDOR').readOnly;
        
        var dataSourceFilter = [];

        dataSourceFilter.push(
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": rowPopup.CDFILIAL
            }
            
        ); //campos requeridos
        
        //CDFILIAL -- DTEMISSAO -- NMTIPOOPER -- CDGRUPO -- CDCLIENTE -- SGESTADO -- CDVENDEDOR -- NMPRODINI-P_PRODINI
        // -- NMPRODFIN-P_PRODINI -----------
        
        if(rowPopup.DTEMISSAO != '' && rowPopup.DTEMISSAO != undefined){ //data de emissão
            dataSourceFilter.push(
                {
                    "name": "DTEMISSAO",
                    "operator": "=",
                    "value": rowPopup.DTEMISSAO
                }
            );
        } //-- DTEMISSAO
    
        if(rowPopup.NMPRODINI != '' && rowPopup.NMPRODINI != undefined){
            
            dataSourceFilter.push(
                {
                    "name": "CDARVPROD",
                    "operator": "BETWEEN",
                    "value": [rowPopup.P_PRODINI, rowPopup.P_PRODFIN]
                }
            );
        } //-- NMPRODINI ?--NMPRODFIM
        
        if (rowPopup.CDVENDEDOR != undefined && rowPopup.CDVENDEDOR != ""){
            dataSourceFilter.push(
                {
                    "name": "CDVENDEDOR",
                    "operator": "=",
                    "value": rowPopup.CDVENDEDOR
                }
            );
            
        } //-- CDVENDEDOR
        
        if (rowPopup.CDTIPOOPER != undefined){
            if(rowPopup.CDTIPOOPER != ''){
                dataSourceFilter.push(
                    {
                        "name": "CDTIPOOPER",
                        "operator": "IN",
                        "value": rowPopup.CDTIPOOPER
                    }
                );
            }
        } //-- CDTIPOOPER
        
        if (rowPopup.CDGRUPO != undefined){
            if(rowPopup.CDGRUPO != ''){
                dataSourceFilter.push(
                    {
                        "name": "CDGRUPO",
                        "operator": "IN",
                        "value": rowPopup.CDGRUPO
                    }
                );
            }
        } //-- CDGRUPO
        
        if(rowPopup.CDCLIENTE != undefined){
            if(rowPopup.CDCLIENTE != ''){
                dataSourceFilter.push(
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": rowPopup.CDCLIENTE
                    }
                );
            }
        } //-- CDCLIENTE
        
        if(rowPopup.SGESTADO !== undefined){
            if(rowPopup.SGESTADO.length != 0){
                dataSourceFilter.push(
                    {
                        "name": "SGESTADO",
                        "operator": "IN",
                        "value": rowPopup.SGESTADO
                    }
                );
            }
        } //-- SGESTADO
        

        
        General.callRestEngine("ped#/crud/parampedido", 'FilterData', [{name: 'CDFILIAL', operator: '=', value: 'FILIAL_LOGADA'}]).then(function (success){
            if((rowPopup.CDVENDEDOR != undefined && !readonlyVendedor) || 
            (rowPopup.CDVENDEDOR != undefined && rowPopup.CDVENDEDOR != "" && readonlyVendedor) ||
            (rowPopup.CDVENDEDOR != undefined && success.dataset.parampedido[0].IDEXIBPEDIDO == "1")||
            (success.dataset.parampedido[0].IDEXIBPEDIDO == "2" && !readonlyVendedor)){
                
                args.owner.dataSourceFilter = dataSourceFilter;
        
                args.owner.container.getWidget('widget_relatorio_customizavel_curvaabc').reload();
            }else{
                ScreenService.showMessage('Operador não relacionado a um vendedor.');
            }
        });
    };

    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        if(widget.getField('NMPRODFIN').readOnly == true){ 
            widget.currentRow.NMPRODFIN = "";
        }
        widget.reload();
        this.prodFin(widget);
        
    };
    this.prodFin = function(widget){

        var row = widget.currentRow;
        
        if(row.NMPRODFIN){
            if(row.P_PRODINI > row.P_PRODFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            }
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('ped02000_relatorio_customizavel_curvaabc_Controller', ped02000_relatorio_customizavel_curvaabc_Controller);
});
